
public class IntTest
{
    public static int[] reverse(int[] array)
    {
        int[] out = new int[array.length];
        
        for(int i = array.length-1; i >= 0; --i)
        {
            out[i] = array[array.length - i - 1];
        }
        
        return out;
    }
    
    /**
     * Display all elements in an int array
     * 
     * @param list List of ints
     */
    public static void display(int[] list)
    {
        for(int i = 0; i < list.length; ++i)
        {
            System.out.print(list[i] + " ");
        }
        System.out.println("");
    }
    
    /**
     * Insert a value into a sorted list
     * 
     * @param val New value to add
     * @param list Sorted list
     * @return Sorted list that includes all elements
     */
    public static int[] insert(int val, int[] list)
    {
        // New array
        int[] out = new int[list.length + 1];
        
        int i;
        
        // Loop until we find the point to insert the new element
        for(i = 0; (val > list[i]) && (i < list.length); ++i) {
            out[i] = list[i];
        }
        
        // Add the new element
        out[i] = val;
        
        // Add the remaining items in the list
        for(; i < list.length; ++i)
        {
            out[i+1] = list[i];
        }
        
        return out;
    }
    
    public static void main(String[] args)
    {
        int[] list = {4, 8, 14, 89};
        
        /*
        int sum = 0;
        
        for(int i = 0; i < list.length; ++i)
        {
            sum += list[i];
        }
        
        System.out.println("The sum is :" + sum);
        
        int[] newList = reverse(list);
        
        display(newList);
        */
        
        display(list);
        
        int[] newList = insert(17, list);
        display(newList);
    }
}
